Leetcode - 001 - Two Sum

来自牛奶河Wiki
阿奔讨论 | 贡献2024年4月24日 (三) 10:16的版本 (创建页面,内容为“1. Two Sum Easy Given an array of integers nums and an integer target, return indices of the two numbers such that they add up to target. You may assume that each input would have exactly one solution, and you may not use the same element twice. You can return the answer in any order. <small>Example 1: Input: nums = [2,7,11,15], target = 9 Output: [0,1] Explanation: Because nums[0] + nums[1] == 9, we return [0, 1]. Example 2: Input: nums = [3,2…”)
(差异) ←上一版本 | 最后版本 (差异) | 下一版本→ (差异)
跳到导航 跳到搜索

1. Two Sum

Easy

Given an array of integers nums and an integer target, return indices of the two numbers such that they add up to target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

You can return the answer in any order.

Example 1:

Input: nums = [2,7,11,15], target = 9
Output: [0,1]
Explanation: Because nums[0] + nums[1] == 9, we return [0, 1].

Example 2:

Input: nums = [3,2,4], target = 6
Output: [1,2]

Example 3:

Input: nums = [3,3], target = 6
Output: [0,1]
Constraints:

    2 <= nums.length <= 104
    -109 <= nums[i] <= 109
    -109 <= target <= 109
    Only one valid answer exists.


class lc001 {
    public static int[] twoSum(int[] nums, int target) {
        HashMap<Integer, Integer> m1 = new HashMap<>();

        for (int i = 0; i < nums.length; i++) {
            if (m1.containsKey(target - nums[i]))
                return new int[] {m1.get(target - nums[i]), i};
            if(!m1.containsKey(nums[i]))
                m1.put(nums[i], i);
        }

        return new int[] {};
    }

    public static void main(String[] args) {
        int[] nums = {2,7,11,15};
        int target = 9;

//        int[] nums = {3,2,4};
//        int target = 6;

//        int[] nums = {3,3};
//        int target = 6;

//        //special
//        int[] nums = {3,2,3,5,15};
//        int target = 8;

        System.out.println(Arrays.toString(twoSum(nums, target)));
    }
}